// 6TMV-HW3-V400 Voor PIC met oscillator 16MHz
// UNIV-6TMV400 Voor PIC met oscillator 18.1818MHz
// 6TMV3.01 AM/PM kwam 1 uur te laat, gefikst
// 6TMV3.00 Eerste versie - verstuurd naar Rex Wiederanders 30 maart
// Nieuwe versie die ook WWVB aankan

// V2.67-73A
// nog niks gewijzigd
// RTC elke seconde bijwerken
// DCF77 bits tellen en checken op goede aantal van 59

// V2.66-73A
// wat overbodige declaraties opgeruimd
// fix probleem DCF77 waarbij uitgang hoog bleef en DCF77 signaal frustreerde

// V2.65-73A
// automatisch RTC detectie

// V2.64-73A Geschikt gemaakt voor 73A
// V2.64 
// Compilerend met de nieuwe PICC compiler gekocht in julie 2004

// V2.63 
// Verbetering decimale punt

// V2.62
// Verbetering van DCF77 betrouwbaarheid

// V2.61
// bugfix DCF77 ging op output en werkt niet als ingang volgens gebruiker(s)

// V2.6 
// toevoegen van optie om 1 uur af te trekken van DCF77, i.v.m. UK locatie

// V2.5 
// onderdrukken van leading zero in 12hr formaat
// op nul stellen van timer variabelen, zodat de
// eerste seconde-tik pas valt *na* 1 seconde power on
// dit voorkomt verlopen bij aan/uitschakelen en RTC
// bruikbaar voor V1 hardware, zie #define

// V2.4 
// Nieuwe optie, 12/24 hr formaat 0=12 uur, 1=24uur

// V2.3 DS1203 RTC clock

// V2.2 poging om buizen te 'faden'

// save version clock3.c notsynced - knippert bij opstarten, totdat gelijk gezet wordt
// clock.c = werkfile, toevoegen van DCF decodering
// versie 1.2 -> clock 12.c div bugfix dcf77

//#define HARDWAREV1

#LIST
// Copyright(c) Frank Bemelman
// ---------------------------
// Auteur: Frank Bemelman
// Nixie Klok
// Software voor PIC16F87x 

// Kies hier uw processor
#define PROCESSOR16F876A

// ***** A T T E N T I E ******
//   char  -> 8 bit UNSIGNED !!!
//   int   -> 8 bit UNSIGNED !!!
//   long  -> 16 bit UNSIGNED !!!
//   short -> 1 bit !!!
//   signed int -> 8 bit signed !!!
//
//   De PIC is dus een hele rare omgeving !!!!
//
// DEFAULT data types zijn UNSIGNED !!!!!!!!!!!!!
// gebruik daarom (bijvoorbeeld) signed long & signed int


#define CRYSTAL 16000000

  // bij 16 mhz kristal, 200us interrupt
  // reload 65536-800, 800 * 250nS, (250ns = 16mhz/4) 
  // 12uSec overhead, dus 48 minder 
  // maw 65536 - (800 - 48) = 64784
  // #define RELOADVALUE 64784
  // dit bleek +7 minuten op 660 minuten te snel, ofwel 1% te snel
  // nieuwe reload waarde wordt 65536 - (752 + 1%) -> 760

#define RELOADVALUE 64776

//#define RELOADVALUE 64500  /*60HZ*/

//#define RELOADVALUE 64300 /* 50HZ */

// Beschrijving van de aansluitingen op de PIC16C73A
// --------------------------------------------------------
//

#ifdef HARDWAREV1

// PIN 02 RA0 - Analoge ingang voor 0 - 5 volt DCLOW
// PIN 03 RA1 - sel3/ spkr
// PIN 04 RA2 - sel2
// PIN 05 RA3 - sw1
// PIN 06 RA4 - uitgang neons
// PIN 07 RA5 - uitgang leds

#define TRISA 0b11001000 // '1' betekent input

#define SW1          PIN_A3
#define SELNEONS     PIN_A4
#define SELLEDS      PIN_A5


#define TRISC 0b00000000 // '1' betekent input
// PIN 11 RC0 - sel8
// PIN 12 RC1 - sel9
// PIN 13 RC2 - sel7
// PIN 14 RC3 - sel6
// PIN 15 RC4 - sel5
// PIN 16 RC5 - enable RS485 & spkr
// PIN 17 RC6 - tx
// PIN 18 RC7 - rx

#define ATOMTIME  PIN_A2

#define RST1302   PIN_A0
#define SCLK1302  PIN_A1
#define IO1302    PIN_A2

#define SELDIG4      PIN_C5
#define SELDIG3      PIN_C7
#define SELDIG2      PIN_C6

#define SELDIG5  PIN_C4
#define SELDIG6  PIN_C3
#define SELDIG7  PIN_C2
#define SELDIG9  PIN_C1
#define SELDIG8  PIN_C0

// PIN 21 RB0 - sel0
// PIN 22 RB1 - sel1
// PIN 23 RB2 - seltube5
// PIN 24 RB3 - seltube6
// PIN 25 RB4 - seltube3
// PIN 26 RB5 - seltube4
// PIN 27 RB6 - seltube1
// PIN 28 RB7 - seltube2

#define TRISB 0b00000000 // '1' betekent input

#define SELTUB1  PIN_B7
#define SELTUB0  PIN_B6
#define SELTUB3  PIN_B5
#define SELTUB2  PIN_B4
#define SELTUB5  PIN_B3
#define SELTUB4  PIN_B2
#define SELDIG1  PIN_B1
#define SELDIG0  PIN_B0

#else

// PIN 02 RA0 - Analoge ingang voor 0 - 5 volt DCLOW
// PIN 03 RA1 - sel3/ spkr
// PIN 04 RA2 - sel2
// PIN 05 RA3 - sw1
// PIN 06 RA4 - uitgang selneons    
// PIN 07 RA5 - uitgang sel leds

#define TRISA 0b11001000 // '1' betekent input

#define SELDIG4      PIN_A0
#define SELDIG3      PIN_A1
#define SELDIG2      PIN_A2
#define SW1          PIN_A3
#define SELNEONS     PIN_A4
#define SELLEDS      PIN_A5


#define TRISC 0b00000000 // '1' betekent input
// PIN 11 RC0 - sel8
// PIN 12 RC1 - sel9
// PIN 13 RC2 - sel7
// PIN 14 RC3 - sel6
// PIN 15 RC4 - sel5
// PIN 16 RC5 - enable RS485 & spkr
// PIN 17 RC6 - tx
// PIN 18 RC7 - rx

#define ATOMTIME  PIN_C7

#define RST1302   PIN_C5
#define SCLK1302  PIN_C6
#define IO1302    PIN_C7

#define SELDIG5  PIN_C4
#define SELDIG6  PIN_C3
#define SELDIG7  PIN_C2
#define SELDIG9  PIN_C1
#define SELDIG8  PIN_C0

// PIN 21 RB0 - sel0
// PIN 22 RB1 - sel1
// PIN 23 RB2 - seltube5
// PIN 24 RB3 - seltube6
// PIN 25 RB4 - seltube3
// PIN 26 RB5 - seltube4
// PIN 27 RB6 - seltube1
// PIN 28 RB7 - seltube2

#define TRISB 0b00000000 // '1' betekent input

#define SELTUB1  PIN_B7
#define SELTUB0  PIN_B6
#define SELTUB3  PIN_B5
#define SELTUB2  PIN_B4
#define SELTUB5  PIN_B3
#define SELTUB4  PIN_B2
#define SELDIG1  PIN_B1
#define SELDIG0  PIN_B0

#endif

// flags als tijd veranderd is
#define CH_SECS1  0x01
#define CH_SECS10 0x02
#define CH_MINS1  0x04
#define CH_MINS10 0x08
#define CH_HRS1   0x10
#define CH_HRS10  0x20


// Include files en specifieke compiler #pragmas
// ---------------------------------------------

#ifdef PROCESSOR16F876A
#include <c:\picc\devices\16F876A.H>
#endif


#FUSES HS, PROTECT,NOWDT,PUT,BROWNOUT,NOLVP
#USE FAST_IO(A)
#USE FAST_IO(B)
#USE FAST_IO(C)

#use delay(clock=CRYSTAL)

unsigned int tclock[6];    // actuele tijd
unsigned int dclock[6];    // displaywaarde
unsigned int mclock[6];    // correctie
unsigned int colonbits;    // welke decimal points staan aan
unsigned int clockmode;    // wat staat er op de display
unsigned int MyOptions[6]; // allerlei opties

// clockmodes
#define CM_ALLOFF      0
#define CM_TIMERUN     1
#define CM_SETTIME     2
#define CM_SETCOR      3
#define CM_SETTUBESAVE 4
#define CM_SETOPTIONS  5
#define CM_SETALARM    6

// options
#define OPTION_ANIMODE  0
#define OPTION_1224HR   1
#define OPTION_ATOMADD  2
#define OPTION_ATOMSUB  3
#define OPTION_FADING   4
#define OPTION_NEONS    5

unsigned int keys[3]; // geeft tijd in ms dat toets is ingedrukt
int keyPressed[3];   // geeft aan dat toets ingedrukt is/was
#define KEYDOWN    3
#define KEYUP      2 
#define KEYSET     1  
#define KEYPOWER   0

// Globale declaraties
// -------------------

unsigned long StartUp;        // opstart vertraging (voor hardware teller)
unsigned long correction;     // correctie per uur, in msec (in stappen van ~9 sec per jaar)
unsigned long newcorrection;

unsigned int flasher;
unsigned int nextfase; // gaat elke msek
unsigned int fase;
unsigned int RunState; // geeft opstart, run, en uitschakel status aan.

unsigned int ClockAction;
#define WARMUP  0
#define POWERUP 1
#define RUNNING 2

// Eeprom stuff
// Eeprom (i2c) serial eeproms beslaan altijd 256 adressen
// om de tweede helft van de AT24C04 te adresseren
// moet A0 bit in device-adress byte aangepast worden
// wat we in dit programma niet nodig hebben en dus niet doen
unsigned int EepromAdr;		// adres binnen AT24C04 e2prom (1 kbit)
unsigned int EepromData;

#BYTE EEDATA = 0x10C
#BYTE EEADR  = 0x10D
#BYTE EEDATH = 0x10E
#BYTE EEADRH = 0x10F
#BYTE EECON1 = 0x18C
#BYTE EECON2 = 0x18D

#define XXXXOPTIONFADING  0x01
#define XXXXOPTIONCOLONS  0x02
#define XXXXOPTIONDCF77   0x04
#define OPTION1203    0x08
#define XXXXOPTION12HR    0x10
#define XXXXOPTIONDCF77UK 0x20


// Functie Prototypes
void do_keyboard(void); // elke msec
void HardInit(void);
unsigned int ReadFromE2prom(unsigned int adress);
void SaveToE2prom(unsigned int value, unsigned int adress);
void LoadParameters(void);
void SaveParms(void);
void settubeon(void);
void settubeoff(void);
void advance_clock(void);
void SetDisplayTime(void);
void GetDisplayTime(void);
void prepare_display(void);
void edit_time(void);
void setcor(void);
void settubesave(void);
void setoptions(void);
void DecodeDCF77(void);
void InitDS1203(void);
void GetTimeDS1203(void);
void SetTimeDS1203(void);
void WriteToDS1203(void);
void ReadFromDS1203(void);
void ConvertFromBCD(void);
void ConvertToBCD(void);
void DecodeWWVB(void);
void AtomicTime(void);

// tijdens powerdown worden sommige waarden in e2prom snel opgeslagen
// hiervoor zijn onderstaande arrays in het leven geroepen.
// iPars wordt door het programma geactualiseerd bij nieuwe tellingen e.d.
// Bij powerdown, wordt Ipars vergeleken met ePars, en de verschillen
// worden dan opgeslagen.
// Parameters zoals ingesteld aantal worden steeds direct opgeslagen, het
// heeft geen zin om hiermee te wachten tot power down.

// specifieke eprom adressen:
#define AFIRST          0x20
#define ASETH           0x20  // correctie H
#define ASETL           0x21  // correctie L
#define AOPTIONS        0x22  // options
#define AOPTIONSFF      0x23  // options ^ 0xff
#define AOPTIONS0       0x24  // options ^ 0xff
#define AOPTIONS1       0x25  // options ^ 0xff
#define AOPTIONS2       0x26  // options ^ 0xff
#define AOPTIONS3       0x27  // options ^ 0xff
#define AOPTIONS4       0x28  // options ^ 0xff
#define AOPTIONS5       0x29  // options ^ 0xff
#define AWWVBDST        0x2A  // options ^ 0xff
#define ASTARTSAVEHR    0x2B  // hoe laat powersave
#define ASTOPSAVEHR     0x2C  // hoe laat powersave
#define ALAST           0x2D  // altijd 1 hoger dan laatste adres definitie !!!!!!!!!!


unsigned int iPars[ALAST-AFIRST]; // initialiseren met e2prom vanaf 0x20 (ACNTL)
unsigned int ePars[ALAST-AFIRST]; // shadow van e2prom waarden

unsigned int tube;
unsigned int digit;
unsigned int prevdigit;
unsigned int second;

unsigned int chooseselect;
unsigned long key1;
unsigned int editdigit;
unsigned int keyreleased;

unsigned int dutyselect;
signed long CompilerBugWorkaround; // deze variable gaat de mist in (page boundary ?)
unsigned int mSek1; 
unsigned int mSek10;
unsigned long uSec;
unsigned long prevkey;
unsigned int makecorrection;
unsigned int tempval;
unsigned int timechanged;
unsigned int minutes60;
unsigned int aclock[6];  // alarm tijd
unsigned int StopSaveHr;
unsigned int StartSaveHr;

unsigned int DimTubes;
unsigned int TubesOn;

unsigned int UtcSeconds;
unsigned int UtcMinutes;
unsigned int UtcHours;
unsigned int UtcDST;
unsigned int LocalHours;

unsigned int NotSynced;

unsigned int  AtomTimeFiltered;
unsigned int  AtomTimeFilteredOld;
unsigned int  AtomTimeSignal;
unsigned long AtomTimeLow;
unsigned long AtomTimeHigh;
unsigned long AtomTimePulse;
unsigned int  AtomTimeSynched;

unsigned int Dcf77Bits;
unsigned int Dcf77Minutes;
unsigned int Dcf77Hours;
unsigned int Dcf77MinutesParity;
unsigned int Dcf77HoursParity;

unsigned int  wwvbBits;
unsigned int  wwvbMinutes;
unsigned int  wwvbHours;
unsigned int  wwvbCheckMinutes;
unsigned int  wwvbCheckHours;
unsigned int  wwvbDST;
unsigned int  wwvbMarker;

unsigned int FadeInLevel;
unsigned int FadeOutLevel;
unsigned int FadeSpeed;
unsigned int fclock[6];  // oude fadeout time
#define SPEEDOFFADE 40

unsigned int Options;

unsigned int Read1302;
unsigned int Write1302;
unsigned int Command1302;
unsigned int ValTris;
unsigned int nop;
unsigned int Convert;

unsigned int  CenterLed;
unsigned int  CenterLedNormal;
unsigned int  PM;

main()
{ 
  // initaliseer PIC hardware 
  HardInit(); // tris registers, schakeluitgangen, ad-conversie etc.

  // laad parameters als moduleadres, pwm-waarde, werkmodus etc.
  LoadParameters();

  InitDS1203();

  second = 0;
  mSek10 = 0;
  uSec = 0;

  while (TRUE)
  { 

    if(second)
    { advance_clock();
      second = 0;

      if(clockmode==CM_TIMERUN)
      { if(CenterLedNormal)CenterLedNormal--;
      }
    }

    // eens per afgedraaid uur, correctiewaarde herinitialiseren
    if(timechanged & CH_MINS1)
    { timechanged &= CH_MINS1 ^ 0xff;
      minutes60++;
      if(minutes60==60)
      { minutes60 = 0;
        newcorrection += correction;
        newcorrection += 2031;
      }
      // benodigde correctie per (resterende) minuut bepalen
      tempval = (unsigned int)(newcorrection / (unsigned long)(60-minutes60));
      // max correctie is 9999, per minuut max 166
      makecorrection =  tempval;
      newcorrection -= tempval;

    }
    
    prepare_display();

    if(StartUp)
    { StartUp--;
      fase++;
      if(fase>3)fase=0;
      while(nextfase != fase);
    }
    else // teller is in werking
    { if(nextfase==fase) // tijd voor een nieuwe actie, elke msek
      { switch(fase)
        { case 0:      // update van rode display

            if(DimTubes) // nachtstand, display uit
            { if(key1)   // toets?
              { // forceer display aan
                TubesOn =  100; // 50 x 10ms display
              }
              else if (TubesOn<50)
              { TubesOn =  0; // display uit
              }
            }
            else
            { TubesOn =  50; // 50 x 10ms display
            }


            break;
          case 1:     // update van groene display
            break;
          case 2:     // teller == preset ????
            Flasher++;
            if(Flasher>125)Flasher=0; // halve seconde
            if(CenterLed)CenterLed--;
            break;

          case 3: // elke 4 msek deze state uitvoeren    
            break;

          default:
            break;
        }

        switch(ClockAction)
        { case POWERUP:
            clockmode = CM_TIMERUN;
            ClockAction = RUNNING;
            break;
          default:
            break;
        }
        do_keyboard();
        AtomicTime();
        fase++;
        if(fase>3)fase=0;
        if(FadeSpeed)FadeSpeed--;
        else
        { FadeSpeed = SPEEDOFFADE;
          if(FadeOutLevel<8)
          { FadeOutLevel++;
          }
          if(FadeOutLevel>3)
          { if(FadeInLevel)FadeInLevel--;
          }
        }
      }
    }
  }
}  


void do_keyboard(void) // elke msec
{ if(INPUT(SW1)==0)
  { if(key1 == 0)CenterLed = 0;
    if(key1<5000)key1++;
    CenterLedNormal = 10;
  }
  else
  { if(chooseselect == CM_ALLOFF)
    { if(clockmode != CM_TIMERUN)
      { chooseselect = clockmode;
        if(chooseselect==CM_SETTIME)
        { // pak je juiste tijd, indien in 12 hr mode
          // is dat toch de 24 uurs tijd.
          GetDisplayTime();
        }
      }
      else CenterLed = 50;
    }
    prevkey = key1;
    key1 = 0;
    keyreleased = 1;
  }

  // druk knop in, na 5 seconde, eerste keuze, na elke volgende 2 seconde, volgende keuze
  if(chooseselect == CM_ALLOFF)
  { if(key1==100)
    { NotSynced = 0;
    }
    if(clockmode == CM_TIMERUN)
    { if(key1==5000)
      { clockmode = CM_SETTIME;
        NotSynced = 0;
        key1=1;
        CenterLed = 50;
        colonbits = 0;
        editdigit = 0;
      }
    }
    else if(clockmode == CM_SETTIME)
    { if(key1==2000)
      { clockmode = CM_SETCOR;
        key1=1;
        CenterLed = 50;
        colonbits = 1;
        editdigit = 0;
      }
    }
    else if(clockmode == CM_SETCOR)
    { if(key1==2000)
      { clockmode = CM_SETTUBESAVE;
        key1=1;
        CenterLed = 50;
        colonbits = 2;
        editdigit = 1;
      }
    }
    else if(clockmode == CM_SETTUBESAVE)
    { if(key1==2000)
      { clockmode = CM_SETOPTIONS;
        key1=1;
        colonbits = 3;
        editdigit = 0;
      }
    }
  }
  else // choose select bevat keuze
  { colonbits = editdigit;
    if(prevkey>25)
    { if(prevkey<250) // korte toets
      { if(chooseselect==CM_SETTIME)edit_time();
        else if(chooseselect==CM_SETCOR)setcor();
        else if(chooseselect==CM_SETTUBESAVE)settubesave();
        else if(chooseselect==CM_SETOPTIONS)setoptions();
      }
    }    
    else
    { if(key1==1000)
      { editdigit++;
        CenterLed = 50;
        if(chooseselect==CM_SETTUBESAVE)
        { if(editdigit>1)
          { if(editdigit>4)editdigit=1;
            else editdigit=5;
          }
        }

        if(chooseselect==CM_SETCOR)
        if(editdigit>3)editdigit=0;

//      if(chooseselect==CM_SETOPTIONS)
//      if(editdigit>4)editdigit=0;

        if(editdigit>5)
        { editdigit=0;
        }
      }
      if(key1==5000)
      { if(chooseselect==CM_SETCOR)SaveParms();
        if(chooseselect==CM_SETTIME)
        { mSek10 = 0;
          Second = 0;
          SetDisplayTime();
          advance_clock();
          advance_clock();
          advance_clock();
          advance_clock();
          advance_clock();
          if(Options & OPTION1203)  // rtc clock?
          { SetTimeDS1203();
          }
          AtomTimeSynched=0;
        }
        if(chooseselect==CM_SETTUBESAVE)SaveParms();
        if(chooseselect==CM_SETOPTIONS)SaveParms();
        clockmode = CM_TIMERUN;
        chooseselect = CM_ALLOFF;
        key1=1;
        CenterLed = 250;
      }
    }
  }
}

#INT_TIMER1
timer1_handler(void)
{ int adc; 

  SET_TIMER1(RELOADVALUE); 

  dutyselect++;
  if(dutyselect>0x09)
  { // volgende buis
    dutyselect=0;
    if(tube>=6)
    { tube = 0;  
    }
    else tube++;

    if(tube==0)
    { 
      if(CenterLedNormal)
      { if(CenterLed)output_high(SELLEDS);
        else output_low(SELLEDS);
      }
      else // depends on animation mode
      { // mode
        if(MyOptions[OPTION_ANIMODE]==0) // always off
        { output_low(SELLEDS); 
        }
        else if(MyOptions[OPTION_ANIMODE]==1) // always on
        { output_high(SELLEDS); 
        }
        else if(MyOptions[OPTION_ANIMODE]==2) // seconds flasher
        { if(mSek10<15)output_high(SELLEDS); 
          else output_low(SELLEDS); 
        }
        else if(MyOptions[OPTION_ANIMODE]==3) // atomic time signal
        { if(AtomTimeFiltered)output_low(SELLEDS); 
          else output_high(SELLEDS); 
        }
        else if(MyOptions[OPTION_ANIMODE]==4) // atomic time synched
        { if(AtomTimeSynched)output_high(SELLEDS); 
          else output_low(SELLEDS); 
        }
        else if(MyOptions[OPTION_ANIMODE]==5) // am/pm mode
        { if(PM==0)output_low(SELLEDS); 
          else output_high(SELLEDS); 
        }
      }
    }
  }

  if(dutyselect>0x07)      // eerst de anodes uit,
  { output_low(SELTUB0);
    output_low(SELTUB1);
    output_low(SELTUB2);
    output_low(SELTUB3);
    output_low(SELTUB4);
    output_low(SELTUB5);
    output_low(SELNEONS);
    output_low(SELDIG0);
    output_low(SELDIG1);
    output_low(SELDIG2);
    output_low(SELDIG3);
    output_low(SELDIG4);
    output_low(SELDIG5);
    output_low(SELDIG6);
    output_low(SELDIG7);
    output_low(SELDIG8);
    output_low(SELDIG9);
  }
  else // dutycycle 0 t/m 7
  { if(TubesOn)
    { 
      if(tube<6)
      { // is dit de buis die moet knipperen? 
        if(colonbits == tube)
		{ // dp inverse knipperen met digit
          if(Flasher>100)
		  { settubeoff();            // cijfer van buis uit
 //          output_high(SELNEONS);      // dp aan
		  }
          else
		  { digit = dclock[tube]; // dit is het cijfer van de nieuwe buis
            settubeon(); // cathodes van buis 'Digit' on
		  }
		}
        else // normaal bedrijf
		{ if(dclock[tube]!=fclock[tube])
          { if(dutyselect>=FadeInLevel) // de nieuwe tijd displayen
            { digit = dclock[tube]; // dit is het cijfer van de nieuwe buis
              settubeon(); // cathodes van buis 'Digit' on
            }

            if(dutyselect>=FadeOutLevel) // de oude tijd displayen
            { digit = fclock[tube]; // dit is het cijfer van de oude buis
              settubeon(); // cathodes van buis 'Digit' on
            }
          }
          else 
          { digit = dclock[tube]; // dit is het cijfer van de nieuwe buis
            settubeon(); // cathodes van buis 'Digit' on
          }
        }
      }
      else // tube '7' voor de neons
      {
        if(CenterLedNormal)
        { if(CenterLed)output_high(SELNEONS);
          else output_low(SELNEONS);
        }
        else // depends on animation mode
        { // mode
          if(MyOptions[OPTION_NEONS]==0) // always off
          { output_low(SELNEONS); 
          }
          else if(MyOptions[OPTION_NEONS]==1) // always on
          { output_high(SELNEONS); 
          }
          else if(MyOptions[OPTION_NEONS]==2) // seconds flasher
          { if(mSek10<15)output_high(SELNEONS); 
            else output_low(SELNEONS); 
          }
          else if(MyOptions[OPTION_NEONS]==3) // atomic time signal
          { if(AtomTimeFiltered)output_low(SELNEONS); 
            else output_high(SELNEONS); 
          }
          else if(MyOptions[OPTION_NEONS]==4) // atomic time synched
          { if(AtomTimeSynched)output_high(SELNEONS); 
            else output_low(SELNEONS); 
          }
          else if(MyOptions[OPTION_NEONS]==5) // am/pm mode
          { if(PM==0)output_low(SELNEONS); 
            else output_high(SELNEONS); 
          }
        }
      }
      // turn on anode
      if(tube == 0)output_high(SELTUB0);
      if(tube == 1)output_high(SELTUB1);
      if(tube == 2)output_high(SELTUB2);
      if(tube == 3)output_high(SELTUB3);
      if(tube == 4)output_high(SELTUB4);
      if(tube == 5)output_high(SELTUB5);
      if(tube == 6) // nu alle buizen uit, en de neons inzetten
	  { output_high(SELTUB1);
        output_high(SELTUB3);
	  }
    }
  }
}




unsigned int ReadFromE2prom(unsigned int adress)
{ unsigned int data;

  EEADR = adress;
  BIT_CLEAR(EECON1, 7); // EEPGD, R/W
  BIT_SET(EECON1, 0); // EEPGD, RD
  data = EEDATA;

  return data;
}

void SaveToE2prom(unsigned int value, unsigned int adress)
{ 
  EEADR = adress;
  EEDATA = value;
  BIT_CLEAR(EECON1, 7); // EEPGD, R/W
  BIT_SET(EECON1, 2); // EEPGD, WREN
  DISABLE_INTERRUPTS(GLOBAL);
  EECON2 = 0x55;
  EECON2 = 0xAA;
  BIT_SET(EECON1, 1); // EEPGD, WR
  ENABLE_INTERRUPTS(GLOBAL);
  DELAY_MS(15);             // vlgs specs 4 ms typ, 8 ms max, 15 mS moet zeker voldoende zijn
}




void HardInit(void)
{ int n;
  // initialiseer port direction registers
  // zie #defines in I/O beschrijving
  SET_TRIS_A(TRISA); 

#ifdef HARDWAREV1
  ValTris = TRISA;
  SET_TRIS_A(ValTris); 
  SET_TRIS_C(0); 
#else
  ValTris = 0x80;
  SET_TRIS_C(ValTris); 
#endif

  output_low(RST1302);

  SET_TRIS_B(0); 

  // alle segmenten uit
  output_low(SELDIG2);
  output_low(SELDIG3);
  output_low(SELDIG4);
  output_low(SELDIG5);
  output_low(SELDIG6);
  output_low(SELDIG7);
  output_low(SELDIG8);
  output_low(SELDIG9);
  output_low(SELLEDS);
  output_low(SELNEONS);

  ClockAction = POWERUP;
  clockmode = CM_ALLOFF;
  StartUp=1000;                         // opstart/inregel vertraging
  makecorrection = 0;
  chooseselect = CM_ALLOFF;
  timechanged = 0;
  minutes60 = 59;
  newcorrection = 0;

  UtcSeconds = 0;
  UtcMinutes = 0;
  UtcHours   = 12;

  NotSynced = 1;
  AtomTimeSynched=0;
  CenterLedNormal=0;

  for(n=0;n<6;n++)
  { fclock[n] = 12;
    tclock[n] = 12;
  }

  // initaliseer TIMER1 voor display multiplex via interrupt
  SETUP_TIMER_1(T1_INTERNAL| T1_DIV_BY_1);
  SET_TIMER1(RELOADVALUE);
  ENABLE_INTERRUPTS(INT_TIMER1);

  // 16000000/4->4000000 / 8 -> 2uS
  // int = 256 * 2 uS -> 512uS
  setup_counters(RTCC_INTERNAL, RTCC_DIV_8);
  ENABLE_INTERRUPTS(INT_RTCC);

  ENABLE_INTERRUPTS(GLOBAL);
  Dcf77Bits = 60;
  Dcf77Minutes = 99;
  Dcf77Hours = 99;
  Dcf77MinutesParity = 1;
  Dcf77HoursParity = 1;
  wwvbBits = 61;

}


void SaveParms(void)
{ unsigned int n; 

  iPars[ASETH-AFIRST] = Correction / 256;
  iPars[ASETL-AFIRST] = Correction % 256;
  iPars[ASTARTSAVEHR-AFIRST] = StartSaveHr;
  iPars[ASTOPSAVEHR-AFIRST]  = StopSaveHr;
  iPars[AOPTIONS-AFIRST]  = Options;
  iPars[AOPTIONSFF-AFIRST]  = Options ^ 0xff;

  iPars[AOPTIONS0-AFIRST] = MyOptions[OPTION_ANIMODE];  
  iPars[AOPTIONS1-AFIRST] = MyOptions[OPTION_1224HR];
  iPars[AOPTIONS2-AFIRST] = MyOptions[OPTION_ATOMADD];
  iPars[AOPTIONS3-AFIRST] = MyOptions[OPTION_ATOMSUB];
  iPars[AOPTIONS4-AFIRST] = MyOptions[OPTION_FADING];
  iPars[AOPTIONS5-AFIRST] = MyOptions[OPTION_NEONS];
  iPars[AWWVBDST-AFIRST]  = UtcDST;

  for(n=AFIRST; n<ALAST; n++)
  { if(iPars[n-AFIRST] != ePars[n-AFIRST])
    { SaveToE2prom(iPars[n-AFIRST], n);
      ePars[n-AFIRST] = iPars[n-AFIRST];
    }
  }

}

void LoadParameters(void)
{ unsigned int n;

  // lees opgeslagen waarden
  for(n=AFIRST; n<ALAST; n++)
  { iPars[n-AFIRST] = ReadFromE2prom(n);
    ePars[n-AFIRST] = ReadFromE2prom(n);
  }

  Correction  = iPars[ASETH-AFIRST] * 256;
  Correction += iPars[ASETL-AFIRST];
  if(Correction>9999)Correction = 5000;

  mclock[0]=(unsigned int)(correction/1000L);
  mclock[1]=(unsigned int)((correction/100L)%10L);
  mclock[2]=(unsigned int)((correction/10L)%10L);
  mclock[3]=(unsigned int)(correction%10L);

  MyOptions[OPTION_ANIMODE] = iPars[AOPTIONS0-AFIRST];
  MyOptions[OPTION_1224HR]  = iPars[AOPTIONS1-AFIRST];
  MyOptions[OPTION_ATOMADD] = iPars[AOPTIONS2-AFIRST];
  MyOptions[OPTION_ATOMSUB] = iPars[AOPTIONS3-AFIRST];
  MyOptions[OPTION_FADING]  = iPars[AOPTIONS4-AFIRST];
  MyOptions[OPTION_NEONS]  = iPars[AOPTIONS5-AFIRST];
  UtcDST                    = iPars[AWWVBDST-AFIRST];

  StartSaveHr = iPars[ASTARTSAVEHR-AFIRST];
  StopSaveHr =  iPars[ASTOPSAVEHR-AFIRST];
  if(StartSaveHr>23)
  { StartSaveHr=0;
    StopSaveHr=0;
  }
  if(StopSaveHr>23)
  { StartSaveHr=0;
    StopSaveHr=0;
  }

  Options = iPars[AOPTIONS-AFIRST];
  if(Options != (iPars[AOPTIONSFF-AFIRST] ^ 0xff))
  { Options = OPTION1203;

    MyOptions[OPTION_ANIMODE] = 1;
    MyOptions[OPTION_1224HR]  = 0;
    MyOptions[OPTION_ATOMADD] = 0;
    MyOptions[OPTION_ATOMSUB] = 0;
    MyOptions[OPTION_FADING]  = 1;
    MyOptions[OPTION_NEONS]  = 2;
    UtcDST = 0;
    SaveParms();
  }

}

void settubeon(void)
{ if(Digit==0)        output_high(SELDIG0);
  else if (Digit==1)  output_high(SELDIG1);
  else if (Digit==2)  output_high(SELDIG2);
  else if (Digit==3)  output_high(SELDIG3);
  else if (Digit==4)  output_high(SELDIG4);
  else if (Digit==5)  output_high(SELDIG5);
  else if (Digit==6)  output_high(SELDIG6);
  else if (Digit==7)  output_high(SELDIG7);
  else if (Digit==8)  output_high(SELDIG8);
  else if (Digit==9)  output_high(SELDIG9);
}


void settubeoff(void)
{ output_low(SELDIG0);
  output_low(SELDIG1);
  output_low(SELDIG2);
  output_low(SELDIG3);
  output_low(SELDIG4);
  output_low(SELDIG5);
  output_low(SELDIG6);
  output_low(SELDIG7);
  output_low(SELDIG8);
  output_low(SELDIG9);
  output_low(SELNEONS);
}


void advance_clock(void)
{ UtcSeconds++;
  timechanged |= CH_SECS1;
  if(UtcSeconds>59)
  { UtcSeconds = 0;
    UtcMinutes++;
    timechanged |= CH_MINS1;
    if(UtcMinutes>59)
    { UtcMinutes = 0;
      UtcHours++;
      if(AtomTimeSynched)AtomTimeSynched--;
      timechanged |= CH_HRS1;
      if(UtcHours>23)
      { UtcHours = 0;
      }
    }
  }

  if(Options & OPTION1203)  // rtc clock?
  { SetTimeDS1203();
  }

  fclock[0] = dclock[0];
  fclock[1] = dclock[1];
  fclock[2] = dclock[2];
  fclock[3] = dclock[3];
  fclock[4] = dclock[4];
  fclock[5] = dclock[5];

  // nieuw cijfer, begint op lage sterkte
  FadeSpeed = SPEEDOFFADE;

  if(clockmode == CM_TIMERUN)
  { if(MyOptions[OPTION_FADING])
    { if(NotSynced == 0)
      { FadeOutLevel = 0;
        FadeInLevel  = 8;
      }
    }
  }
}


void SetDisplayTime(void)
{ // tijd in tclock[] omzetten in UTC en opslaan
  // in de UTC variabelen
  UtcSeconds = tclock[4] * 10;
  UtcSeconds += tclock[5];
  UtcMinutes = tclock[2] * 10;
  UtcMinutes += tclock[3];
  UtcHours   = tclock[0] * 10;
  UtcHours   += tclock[1];

  UtcHours+=24;
  UtcHours -= MyOptions[OPTION_ATOMADD];
  UtcHours += MyOptions[OPTION_ATOMSUB];
  while(UtcHours >= 24)UtcHours -= 24;

  if(UtcDST)
  { if(UtcDST==0x01) // eerste dag zomertijd 
    { if(UtcHours>=2)UtcHours--;
    }
    else if(UtcDST==0x03) // zomertijd 
    { UtcHours+=23;
    }
    else // eerste dag wintertijd
    { if(UtcHours<2)UtcHours+=23;
    }
    if(UtcHours >= 24)UtcHours -= 24;
  }

}

void GetDisplayTime(void)
{ unsigned int hrs;

  // zet de tijd om in 6 digits en pas eventueel 
  // de 12HR mode toe, indien niet in CM_SETTIME mode

  LocalHours = UtcHours;
  
  LocalHours += 24;
  LocalHours += MyOptions[OPTION_ATOMADD];
  LocalHours -= MyOptions[OPTION_ATOMSUB];   
  while(LocalHours >= 24)LocalHours -= 24;

  if(UtcDST)
  { if(UtcDST==0x01) // eerste dag zomertijd 
    { if(LocalHours>=2)LocalHours++;
    }
    else if(UtcDST==0x03) // zomertijd 
    { LocalHours++;
    }
    else // eerste dag wintertijd
    { if(LocalHours<2)LocalHours++;
    }
    if(LocalHours >= 24)LocalHours -= 24;
    if(iPars[AWWVBDST-AFIRST]  != UtcDST)SaveParms();
  }

  if(LocalHours>=12)PM=1;
  else PM=0;

  tclock[5] = UtcSeconds % 10;
  tclock[4] = UtcSeconds / 10;
  tclock[3] = UtcMinutes % 10;
  tclock[2] = UtcMinutes / 10;
  tclock[1] = LocalHours % 10;
  tclock[0] = LocalHours / 10;

  if(clockmode != CM_SETTIME)
  { hrs= LocalHours;
    if(MyOptions[OPTION_1224HR])  // 12 hour format clock?
    { if(hrs==0)hrs+=12;
      if(hrs>12)
      { hrs -= 12;
      }
      else
      { if(hrs==0)hrs+=12;
      }
      tclock[1] = hrs % 10;
      tclock[0] = hrs / 10;
      // leading zero suppresion
      if(tclock[0]==0)tclock[0]=12;
    }
  } 
}

void prepare_display(void)
{ 
  // in principe buizen aan
  DimTubes = 0; 

  switch(clockmode)
  { case CM_TIMERUN:
      GetDisplayTime();
      dclock[0]=tclock[0];
      dclock[1]=tclock[1];
      dclock[2]=tclock[2];
      dclock[3]=tclock[3];
      dclock[4]=tclock[4];
      dclock[5]=tclock[5];
      colonbits = 7;

      // tenzij...
      if(StartSaveHr>StopSaveHr)
      { // 21 - 19
        if(LocalHours>=StartSaveHr)DimTubes =  1;
        if(LocalHours<StopSaveHr)DimTubes =  1;
      }
      
      if(StartSaveHr<StopSaveHr)
      { // 19 - 21
        if(LocalHours>=StartSaveHr)
        { if(LocalHours<StopSaveHr)DimTubes =  1;
        }
      }

      // tenzij...
      if(NotSynced) 
      { if(mSek10>50) // laten knipperen
        { DimTubes =  1; 
        }
      }
      break;

    case CM_SETTIME:
      dclock[0]=tclock[0];
      dclock[1]=tclock[1];
      dclock[2]=tclock[2];
      dclock[3]=tclock[3];
      dclock[4]=tclock[4];
      dclock[5]=tclock[5];
      break;

    case CM_SETCOR:
      dclock[0]=mclock[0];
      dclock[1]=mclock[1];
      dclock[2]=mclock[2];
      dclock[3]=mclock[3];
      dclock[4]=15;
      dclock[5]=15;
      break;

    case CM_SETTUBESAVE:
      dclock[0]=StartSaveHr/10;
      dclock[1]=StartSaveHr%10;
      dclock[2]=15;
      dclock[3]=15;
      dclock[4]=StopSaveHr/10;
      dclock[5]=StopSaveHr%10;
      break;

    case CM_SETOPTIONS:
      dclock[0]=MyOptions[0];
      dclock[1]=MyOptions[1];
      dclock[2]=MyOptions[2];
      dclock[3]=MyOptions[3];
      dclock[4]=MyOptions[4];
      dclock[5]=MyOptions[5];
      break;


    default:
      // display niets
      dclock[0]=15;
      dclock[1]=15;
      dclock[2]=15;
      dclock[3]=15;
      dclock[4]=15;
      dclock[5]=15;
      colonbits = 7;
      break;
  }  

}

void edit_time(void)
{ switch(editdigit)
  { case 0:
      if(tclock[0]>=2)
      { tclock[0]=255;
      }     
      tclock[0]++;     
      if(tclock[0]>=2)
      { if(tclock[1]>=3)
        { tclock[1]=3;
        }
      }
      break;
    case 1:
      if(tclock[1]>=9)
      { tclock[1]=255;     
      }     
      else
      if(tclock[0]>=2)
      { if(tclock[1]>=3)
        { tclock[1]=255;
        }
      }
      tclock[1]++;     
      break;
    case 3:
    case 5:
      if(tclock[editdigit]>=9)
      { tclock[editdigit]=255;     
      }     
      tclock[editdigit]++;     
      break;
    case 2:
    case 4:
      if(tclock[editdigit]>=5)
      { tclock[editdigit]=255;     
      }     
      tclock[editdigit]++;     
      break;
  }
}

void settubesave(void)
{ 
  switch(editdigit)
  { case 0:
    case 1:
      StartSaveHr++;
      if(StartSaveHr>23)StartSaveHr=0;
      break;

    case 4:
    case 5:
      StopSaveHr++;
      if(StopSaveHr>23)StopSaveHr=0;
      break;
  }

}

void setcor(void)
{ 
  switch(editdigit)
  { case 0:
    case 1:
    case 2:
    case 3:
      if(mclock[editdigit]>=9)
      { mclock[editdigit]=255;     
      }     
      mclock[editdigit]++;
      break;
    case 4:
    case 5:
      break;
  }

  correction = (unsigned long)mclock[0] * 1000L;
  correction += (unsigned long)mclock[1] * 100L;
  correction += (unsigned long)mclock[2] * 10L;
  correction += (unsigned long)mclock[3];

}

void setoptions(void)
{ MyOptions[editdigit]++;
  if((editdigit==OPTION_ANIMODE) && MyOptions[OPTION_ANIMODE]>5)MyOptions[OPTION_ANIMODE]=0;
  if((editdigit==OPTION_1224HR)  && MyOptions[OPTION_1224HR]>1)MyOptions[OPTION_1224HR]=0;
  if((editdigit==OPTION_ATOMADD) && MyOptions[OPTION_ATOMADD]>9)MyOptions[OPTION_ATOMADD]=0;
  if((editdigit==OPTION_ATOMSUB) && MyOptions[OPTION_ATOMSUB]>9)MyOptions[OPTION_ATOMSUB]=0;
  if((editdigit==OPTION_FADING)  && MyOptions[OPTION_FADING]>1)MyOptions[OPTION_FADING]=0;
  if((editdigit==OPTION_NEONS)   && MyOptions[OPTION_NEONS]>5)MyOptions[OPTION_NEONS]=0;
}


void flash_dp(void)
{ colonbits = editdigit;
}


#INT_RTCC
timer2_handler(void)
{ // 16MHz Crystal
  // Deze interrupt komt elke 0,5 milliseconde. 
  // door 511 ipv 512 loopt de klok per uur 7,031 seconde te langzaam
  // want (511/512) * 3600 maakt dat tekort
  uSec+=511;


  if(uSec>1000)
  { uSec -=1000;
    mSek1++;
    if(mSek1>0x09)
    { mSek1=0;
      mSek10++;

      if(TubesOn)TubesOn--;

      // nog corrigeren per minuut, max 166, max 3mS per seconde
      if(makecorrection)
      { makecorrection--;
        uSec+=1000;
      }

      if(mSek10>99)
      { mSek10=0;
        second=1;
      }
    }
    nextfase++;
    if(nextfase>3)nextfase=0;
  }
}



void InitDS1203(void)
{  

  Command1302 = 0x8e; // controlregister, write
  Write1302 = 0x0;  // write protect off
  WriteToDS1203();

  // test of er een DS1203 aangesloten is
  Command1302 = 0xc0; // ram adres 0, write
  Write1302 = 0xAA;   // pattern
  WriteToDS1203();
  ReadFromDS1203();
  if(Read1302 != 0xAA)
  { // geen 1302 aanwezig, uit de config halen
    if(Options & OPTION1203)
    { Options &= OPTION1203 ^ 0xff;
      SaveParms();
    }
    return;
  }

  if(!(Options & OPTION1203))
  { Options |= OPTION1203;
    SaveParms();
  }

  Command1302 = 0x84; // hours
  ReadFromDS1203();
  if(Read1302 & 0x80) // clock staat in 12hr mode!
  { Write1302 = Read1302; // uren overnemen
    Write1302 &= 0x7f; // 12hr mode uitschakelen
    WriteToDS1203();
  }

  // read seconds
  Command1302 = 0x80; // seconds
  ReadFromDS1203();
  if(Read1302 & 0x80) // clock staat stil!
  { Write1302 = Read1302; // seconds overnemen
    Write1302 &= 0x7f;
    WriteToDS1203();
  }
  else
  { GetTimeDS1203();
    NotSynced = 0;
  }

  Command1302 = 0x90; // trickle charger
  Write1302 = 0xA5; // 1 diode charger, 2K
  WriteToDS1203();

}

void GetTimeDS1203(void)
{ Command1302 = 0x80; // seconds
  ReadFromDS1203();
  ConvertFromBCD();
  UtcSeconds = Convert;  
  if(UtcSeconds>59)UtcSeconds = 0;

  Command1302 = 0x82; // minutes
  ReadFromDS1203();
  ConvertFromBCD();
  UtcMinutes = Convert;
  if(UtcMinutes>59)UtcMinutes = 0;

  Command1302 = 0x84; // hours
  Read1302 &= 0x7f;   // mask 12/24 mode bit
  ReadFromDS1203();
  ConvertFromBCD();
  UtcHours = Convert;
  if(UtcHours>23)UtcHours = 0;
}

void SetTimeDS1203(void)
{ Command1302 = 0x80; // seconds
  Convert = UtcSeconds;    
  ConvertToBCD();
  WriteToDS1203();

  Command1302 = 0x82; // minutes
  Convert = UtcMinutes;    
  ConvertToBCD();
  WriteToDS1203();

  Command1302 = 0x84; // hours
  Convert = UtcHours;    
  ConvertToBCD();
  WriteToDS1203();
}


void WriteToDS1203(void)
{ unsigned int n;

#ifdef HARDWAREV1
  ValTris = TRISA;
  SET_TRIS_A(ValTris); 
#else
  ValTris = 0x0;
  SET_TRIS_C(ValTris); 
#endif

    nop++;
    nop++;

  output_low(SCLK1302);
    nop++;
    nop++;
  output_high(RST1302);
    nop++;
    nop++;

  Command1302 &= 0xfe; // maak er een write van

  n = 0x01;
  while(n)
  { if(Command1302 & n)output_high(IO1302);
    else             output_low(IO1302);
    output_high(SCLK1302);
    nop++;
    nop++;
    output_low(SCLK1302);
    nop++;
    nop++;
    n <<= 1;
  }

  n = 0x01;
  while(n)
  { if(Write1302 & n)output_high(IO1302);
    else             output_low(IO1302);
    output_high(SCLK1302);
    nop++;
    nop++;
    output_low(SCLK1302);
    nop++;
    nop++;
    n <<= 1;
  }

  output_low(RST1302);


#ifdef HARDWAREV1
  ValTris = TRISA | 0x04;
  SET_TRIS_A(ValTris); 
#else
  ValTris = 0x80;
  SET_TRIS_C(ValTris); 
#endif
    nop++;
    nop++;


}

void ReadFromDS1203(void)
{ unsigned int n;

#ifdef HARDWAREV1
  ValTris = TRISA;
  SET_TRIS_A(ValTris); 
#else
  ValTris = 0x0;
  SET_TRIS_C(ValTris); 
#endif

    nop++;
    nop++;

  output_low(SCLK1302);
    nop++;
    nop++;
  output_high(RST1302);
    nop++;
    nop++;

  Command1302 |= 0x01; // maak er een read van

  n = 0x01;
  while(n)
  { if(Command1302 & n)output_high(IO1302);
    else             output_low(IO1302);
    output_high(SCLK1302);
    nop++;
    nop++;
    output_low(SCLK1302);
    nop++;
    nop++;
    n <<= 1;
  }

#ifdef HARDWAREV1
  ValTris = TRISA | 0x04;
  SET_TRIS_A(ValTris); 
#else
  ValTris = 0x80;
  SET_TRIS_C(ValTris); 
#endif
    nop++;
    nop++;

  n = 0x01;
  while(n)
  { if(INPUT(IO1302)==1)Read1302 |= n;
    else                Read1302 &= (n ^ 0xff);
    output_high(SCLK1302);
    nop++;
    nop++;
    output_low(SCLK1302);
    nop++;
    nop++;
    n <<= 1;
  }

  output_low(RST1302);

}

// End of file //

void ConvertFromBCD(void)
{ Convert = Read1302;
  Read1302 &= 0xf0;
  while(Read1302)
  { Convert -= 6;
    Read1302 -= 16;
  }
}

void ConvertToBCD(void)
{ Write1302 = Convert/10;
  Write1302 <<= 4;
  Write1302 += Convert%10;
}

void AtomicTime(void)
{ // filter the input signal to remove
  // short glitches
  if(INPUT(ATOMTIME)==1)
  { if(!AtomTimeFiltered) // signaal is laag
    { if(AtomTimeSignal<25)AtomTimeSignal++;
      else
      { AtomTimeFiltered = 1;
      }
    }
    else
    { AtomTimeSignal = 25;
    }
  }
  else
  { if(AtomTimeFiltered) // signaal is hoog
    { if(AtomTimeSignal)AtomTimeSignal--;
      else
      { AtomTimeFiltered = 0;
      }
    }
    else
    { AtomTimeSignal = 0;
    }
  }

  // flank detectie
  if(AtomTimeFiltered != AtomTimeFilteredOld)
  { AtomTimePulse = AtomTimeLow + AtomTimeHigh;
    AtomTimeFilteredOld = AtomTimeFiltered;

    if(!AtomTimeFiltered)DecodeDCF77(); // decodeer DCF77 op de neergaade flank
    if(!AtomTimeFiltered)DecodeWWVB(); // decodeer WWVB  op de neergaande flank

    if(AtomTimefiltered)AtomTimeHigh = 0;
    else                AtomTimeLow = 0;

  }

  if(!AtomTimeFiltered)
  { // tijdmeting pulse
    AtomTimeLow++;
  }
  else
  { AtomTimeHigh++;
  }
}

void DecodeWWVB(void)
{ // pulsen zijn negatief, en de neergaande flank is het begin van een seconde
  // de opgaande flank geeft de lengte aan, 800ms, 500ms of 200ms. Aan begin
  // en einde v.e. minuut is er een 800ms pulse. De minuten informatie uitgezonden
  // in het telegram is de huidige minuut, die gold bij de start van
  // het telegram

  if((AtomTimePulse>900) && (AtomTimePulse<1100)) // redelijke pulse?
  { if(AtomTimeLow>650) // marker
    { wwvbMarker++;
      if(wwvbMarker>=2)
      { wwvbBits=0;
        wwvbMinutes=0;
        wwvbHours=0;
        wwvbDST=0;
      }
      else if(wwvbBits==59)
      { if(wwvbMinutes>=0)
        { if(wwvbMinutes<60)
          { if(wwvbHours>=0)
            { if(wwvbHours<24)
              { if(wwvbHours == wwvbCheckHours)
                { if(wwvbMinutes == wwvbCheckMinutes)
                  { UtcSeconds = 59;
                    UtcMinutes = wwvbMinutes;

                    UtcHours = wwvbHours;
                    UtcDST = wwvbDST;
                    advance_clock();

                    mSek10 = 2; // vanwege filter
                    mSek1 = 5;  // vanwege filter
                    Second = 0; // onmiddelijk een seconde erbij
                    NotSynced = 0;
                    AtomTimeSynched=24;
                  }
                }
                wwvbCheckHours = wwvbHours;
                wwvbCheckMinutes = wwvbMinutes+1;
              }
            }
          }
        }
      } 
    }
    else
    { wwvbMarker = 0;
      if(AtomTimeLow>350) // binary 1
      { if(wwvbBits==1)wwvbMinutes += 40;
        if(wwvbBits==2)wwvbMinutes += 20;
        if(wwvbBits==3)wwvbMinutes += 10;
        if(wwvbBits==5)wwvbMinutes += 8;
        if(wwvbBits==6)wwvbMinutes += 4;
        if(wwvbBits==7)wwvbMinutes += 2;
        if(wwvbBits==8)wwvbMinutes += 1;
        //
        if(wwvbBits==12)wwvbHours += 20;
        if(wwvbBits==13)wwvbHours += 10;
        if(wwvbBits==15)wwvbHours += 8;
        if(wwvbBits==16)wwvbHours += 4;
        if(wwvbBits==17)wwvbHours += 2;
        if(wwvbBits==18)wwvbHours += 1;
        //
        if(wwvbBits==57)wwvbDST |= 0x01;
        if(wwvbBits==58)wwvbDST |= 0x02;
      }
      else // binary 0
      { 
      } 
    }
  } 
  wwvbBits++; 

}


void DecodeDCF77(void)
{ // pulsen zijn negatief, en de neergaande flank is het begin van een seconde
  // de opgaande flank geeft de lengte aan, 100ms of 200ms. Een pauze van 2
  // seconde is het einde van de minuut. De minuten informatie uitgezonden
  // in het telegram is de komende minuut, die gaat in aan het einde van
  // het telegram



  if((AtomTimePulse>900) && (AtomTimePulse<1100)) // redelijke pulse?
  { if(AtomTimeLow>150) // logic high
    { if(Dcf77Bits==21)
      { Dcf77Minutes = 1; 
        Dcf77MinutesParity++;
      }   
      else if(Dcf77Bits==22)
      { Dcf77Minutes += 2; 
        Dcf77MinutesParity++;
      }   
      else if(Dcf77Bits==23)
      { Dcf77Minutes += 4; 
        Dcf77MinutesParity++;
      }   
      else if(Dcf77Bits==24)
      { Dcf77Minutes += 8; 
        Dcf77MinutesParity++;
      }   
      else if(Dcf77Bits==25)
      { Dcf77Minutes += 10; 
        Dcf77MinutesParity++;
      }   
      else if(Dcf77Bits==26)
      { Dcf77Minutes += 20; 
        Dcf77MinutesParity++;
      }   
      else if(Dcf77Bits==27)
      { Dcf77Minutes += 40; 
        Dcf77MinutesParity++;
      }   
      else if(Dcf77Bits==28)
      { Dcf77MinutesParity++;
      }   
      if(Dcf77Bits==29)
      { Dcf77Hours = 1; 
        Dcf77HoursParity++;
      }   
      else if(Dcf77Bits==30)
      { Dcf77Hours += 2; 
        Dcf77HoursParity++;
      }   
      else if(Dcf77Bits==31)
      { Dcf77Hours += 4; 
        Dcf77HoursParity++;
      }   
      else if(Dcf77Bits==32)
      { Dcf77Hours += 8; 
        Dcf77HoursParity++;
      }   
      else if(Dcf77Bits==33)
      { Dcf77Hours += 10; 
        Dcf77HoursParity++;
      }   
      else if(Dcf77Bits==34)
      { Dcf77Hours += 20; 
        Dcf77HoursParity++;
      }   
      else if(Dcf77Bits==35)
      { Dcf77HoursParity++;
      }   
    }
    Dcf77Bits++; 
  }
  else if((AtomTimePulse>1900) && (AtomTimePulse<2100)) // redelijke pulse?
  { if(Dcf77Bits==58)     // sanity check 1 
    { if(Dcf77Minutes<60) // sanity check 2
      { if(Dcf77Hours<24) // sanity check 3
        { if(Dcf77Minutes>0) // sanity check 4
          { if(Dcf77Hours>0) // sanity check 5
            { if(!(Dcf77MinutesParity & 0x01)) // sanity check 6
              { if(!(Dcf77HoursParity & 0x01)) // sanity check 7
                { UtcSeconds=0;
                  UtcMinutes = Dcf77Minutes;
                  UtcHours = Dcf77Hours;
                  UtcDST = 0;
                  mSek10 = 2; // vanwege filter
                  mSek1 = 5;  // vanwege filter
                  Second = 0;
                  NotSynced = 0;
                  AtomTimeSynched=24;
                }
              }
            }
          }
        }
      }
    }
    Dcf77Bits = 0;
    Dcf77Minutes = 0;
    Dcf77Hours = 0;
    Dcf77MinutesParity = 0;
    Dcf77HoursParity = 0;
  } 
}


// eof